Unit av18e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure av18e(var SA :Extended; var SB :Extended; var C :Extended;
                var S :Extended);
implementation

procedure av18e(var SA :Extended; var SB :Extended; var C :Extended;
                var S :Extended);
var                
IERR :Integer;
R,ROE,SCALE,X,Z :Extended;
label
_10,_20,_40;
begin

{       }
X := 0.0e0;

ROE := SB;
if ( Abs(SA) > Abs(SB) ) 
 then ROE := SA;
SCALE := Abs(SA) + Abs(SB);
if ( SCALE <> 0.0e0 ) 
 then goto _10;
C := 1.0e0;
S := 0.0e0;
R := 0.0e0;
goto _20;
_10:
R := SCALE*Sqrt(IntPower(SA/SCALE,2) + IntPower(SB/SCALE,2));
R := Sign(1.0e0,ROE)*R;
C := SA/R;
S := SB/R;
_20:
Z := 1.0e0;
if ( Abs(SA) > Abs(SB) ) 
 then Z := S;
if ( Abs(SB) >= Abs(SA)) and (C <> 0.0e0 ) 
 then Z := 1.0e0/C;
SA := R;
SB := Z;
goto _40;
_40:
end;

end.
